#include<iostream.h>
#include<stdio.h>
#include<stdlib.h>
#include<ctype.h>
#include<string.h>
#include<unistd.h>
#include"buchtrans_util.h"

CORBA::ULong uname2uid(char *name);

ostream& operator<<(ostream& str,const buch::Kontonr& knr)
{
    str << knr.firnr << ':' << knr.name;
    return str;
}


int leseKontonr(buch::Kontonr& knr,char *kstr,char **pp)
{
   char *nutz;
   char *konto;
   char *p;
   CORBA::ULong firnr;
   
   for(p=kstr;*p!='\0' && !isspace(*p) && *p!=':';p++);
   if(*p=='\0' || isspace(*p)) 
   {
     konto =kstr; nutz="";
   }
   else 
   {
     konto = p+1; *p++ = '\0'; nutz =kstr;
   }

   // cout << "nutz=" << nutz << " Konto " << konto << endl;
   
   if(nutz[0]=='\0') firnr = getuid();
   else if(isdigit(nutz[0])) firnr = atoi(nutz);
   else firnr = uname2uid(nutz);

   // cout << "Uid=" << firnr << " Konto " << konto << endl;
   while(!isspace(*p) && *p!='\0') p++;
   *p++='\0';

   knr.firnr = firnr;
   knr.name = (const char *)konto;
   if(pp!=NULL)
   {
       *pp=p;
   }
   return 1;
}

#include<pwd.h>
#include<sys/types.h>

CORBA::ULong uname2uid(char *name)
{
  struct passwd *pwd = getpwnam(name);
  if(pwd==NULL) return ~(CORBA::ULong)0;
  return pwd->pw_uid;
}

/*------------------------ Halbsatz ------------------*/
ostream& operator<<(ostream& str,const buch::Halbsatz& hs)
{
    str << hs.konto << '\t' << hs.betrag << ' '
	<< (hs.sh == buch::Soll ? 'S' : 'H');
    return str;
}


ostream& operator<<(ostream& str,const buch::date& d)
{
    str << d.tag << '.' << d.monat << '.' << d.jahr;
    return str;
}
