#!/paket/tcl/bin/wish8.0 -f




















 



proc maske {} {
  global m
  frame .f
  message .f.title -text adressen -aspect 1000 -font "Times 24 bold"
  pack .f.title -padx 10 -pady 10
   frame .f.feld1
   label .f.feld1.knrlabel -text "Knr:"
   entry .f.feld1.knrentry -textvariable m(knr) -relief sunken -width 20
   pack .f.feld1.knrlabel -side left -anchor w 
   pack .f.feld1.knrentry -side left -expand 1 -pady 3 -anchor w
   pack .f.feld1 -side top -fill x -pady 6

   frame .f.feld2
   label .f.feld2.namelabel -text "Name:"
   entry .f.feld2.nameentry -textvariable m(name) -relief sunken -width 40
   pack .f.feld2.namelabel -side left -anchor w 
   pack .f.feld2.nameentry -side left -expand 1 -pady 3 -anchor w
   pack .f.feld2 -side top -fill x -pady 6

   frame .f.feld3
   label .f.feld3.strasselabel -text "Strasse:"
   entry .f.feld3.strasseentry -textvariable m(strasse) -relief sunken -width 60
   pack .f.feld3.strasselabel -side left -anchor w 
   pack .f.feld3.strasseentry -side left -expand 1 -pady 3 -anchor w
   pack .f.feld3 -side top -fill x -pady 6

   frame .f.feld4
   label .f.feld4.plzlabel -text "Plz:"
   entry .f.feld4.plzentry -textvariable m(plz) -relief sunken -width 10
   pack .f.feld4.plzlabel -side left -anchor w 
   pack .f.feld4.plzentry -side left -expand 1 -pady 3 -anchor w
   pack .f.feld4 -side top -fill x -pady 6

   label .f.feld4.ortlabel -text "Ort:"
   entry .f.feld4.ortentry -textvariable m(ort) -relief sunken -width 40
   pack .f.feld4.ortlabel -side left -anchor w 
   pack .f.feld4.ortentry -side left -expand 1 -pady 3 -anchor w

   frame .f.b
   button .f.b.suchen -text "Suchen" -command suchen
   button .f.b.clear  -text "Maske frei" -command clearfields
   button .f.b.speichern -text "Speichern" -command speichern
   button .f.b.end -text "Ende" -command ende
   pack  .f.b.suchen  -side left -fill x -expand 1
   pack  .f.b.clear   -side left -fill x -expand 1
   pack  .f.b.speichern -side left -fill x -expand 1
   pack  .f.b.end -side left -fill x -expand 1
   pack  .f.b -fill x -expand 1
   
   label .f.msg -text "" -relief sunken -bd 1 -anchor w
   pack  .f.msg  -side left -padx 2 -expand yes -fill both
   pack .f
}
proc clearfields {} {
 global m status
 foreach f {  knr name strasse plz ort } {
   set m($f) ""
 }
 set status new
}

proc savefields {} {
  global m s
  foreach f {  knr name strasse plz ort } {
    set s($f) $m($f)
  }
}






proc speichern {} {
  global m s env conn adamsg logon status
  if { $status == "found" } {
    set anw "UPDATE ADRESSEN SET ";
    set fc 0

      if { $s(knr) != $m(knr) } {
      if { $fc > 0 } { append anw "," }
      append anw "knr='$m(knr)'"
      incr fc
   }

      if { $s(name) != $m(name) } {
      if { $fc > 0 } { append anw "," }
      append anw "name='$m(name)'"
      incr fc
   }

      if { $s(strasse) != $m(strasse) } {
      if { $fc > 0 } { append anw "," }
      append anw "strasse='$m(strasse)'"
      incr fc
   }

      if { $s(plz) != $m(plz) } {
      if { $fc > 0 } { append anw "," }
      append anw "plz='$m(plz)'"
      incr fc
   }

      if { $s(ort) != $m(ort) } {
      if { $fc > 0 } { append anw "," }
      append anw "ort='$m(ort)'"
      incr fc
   }

    if { $fc > 0 } {
            append anw " WHERE knr = '$m(knr)'"
    } else {
      setmsg "Nichts gendert "
      return
    }
  } else {
    set anw "INSERT INTO ADRESSEN (knr,name,strasse,plz,ort) VALUES ('$m(knr)','$m(name)','$m(strasse)','$m(plz)','$m(ort)')"
  }
  puts stdout $anw

  set res [ pg_exec $conn $anw ]
  set errmsg [ pg_result $res -error ]
  if { $errmsg == "" } {
    setmsg "Satz $m(knr) gespeichert "
    savefields
  } else {
    setmsg $errmsg
  }
}


proc gensuchanw {} {
  global m 
  set anw "SELECT * FROM ADRESSEN"
  set fc 0

      if { [string length [string trim $m(knr)]]>0 } {
     if { $fc == 0 } { append anw " WHERE " } else { append anw " AND " }
     
     if [ regexp {[%\*_\?]} $m(knr)] {
        append anw "knr LIKE '$m(knr)'"
     } else {
        append anw "knr = '$m(knr)'"
     }
     incr fc
   }

      if { [string length [string trim $m(name)]]>0 } {
     if { $fc == 0 } { append anw " WHERE " } else { append anw " AND " }
     
     if [ regexp {[%\*_\?]} $m(name)] {
        append anw "name LIKE '$m(name)'"
     } else {
        append anw "name = '$m(name)'"
     }
     incr fc
   }

      if { [string length [string trim $m(strasse)]]>0 } {
     if { $fc == 0 } { append anw " WHERE " } else { append anw " AND " }
     
     if [ regexp {[%\*_\?]} $m(strasse)] {
        append anw "strasse LIKE '$m(strasse)'"
     } else {
        append anw "strasse = '$m(strasse)'"
     }
     incr fc
   }

      if { [string length [string trim $m(plz)]]>0 } {
     if { $fc == 0 } { append anw " WHERE " } else { append anw " AND " }
     
     if [ regexp {[%\*_\?]} $m(plz)] {
        append anw "plz LIKE '$m(plz)'"
     } else {
        append anw "plz = '$m(plz)'"
     }
     incr fc
   }

      if { [string length [string trim $m(ort)]]>0 } {
     if { $fc == 0 } { append anw " WHERE " } else { append anw " AND " }
     
     if [ regexp {[%\*_\?]} $m(ort)] {
        append anw "ort LIKE '$m(ort)'"
     } else {
        append anw "ort = '$m(ort)'"
     }
     incr fc
   }

  return $anw
}


proc ende {} {
 puts "Und Tsch "
 exit
}

proc setmsg { msg } {
   if [regexp ^ERROR $msg] {
        .f.msg configure -text $msg -foreground red
    } else {
        set defaultColor [lindex [.f.msg configure -foreground] 3]
        .f.msg configure -text $msg -foreground $defaultColor
    }
}

proc suchen {} {
  global m conn adamsg status
  if { [ regexp {^[:0]*$} [string trim "$m(knr)" ]] == 0 } {
    sucheschl "$m(knr)"
  } else {
    freiesuche [ gensuchanw ] { fillfields $key; sucheschl $key }
  }
}

proc fillfields { key } {
  global m
  set kd [split "knr" , ]
  set kl [split $key : ]
  
  for { set i 0 } { $i < [llength $kd ] } { incr i } {
	set f [ lindex $kd $i ]
	set m($f) [ lindex $kl $i ]
  }
}

proc sucheschl { key } {
  global m conn adamsg status	
  set stat "SELECT KNR,NAME,STRASSE,PLZ,ORT FROM ADRESSEN WHERE knr = '$m(knr)'"
  
  puts stdout $stat;
  clearfields
  
  set res [ pg_exec $conn $stat ]
  set errmsg [ pg_result $res -error ]	
  if { $errmsg == "" && [pg_result $res -numTuples ] > 0 } {
    setmsg ""
    pg_result $res -tupleArray 0 m
    savefields
    set status found
  } else {
    if { $errmsg == "" } { set errmsg "$key nicht gefunden " }
    setmsg $errmsg
    set status new
    set m(SCHLUESSEL) $key
  }
}

# Auswahlfenster
proc displayauswahl { title } {
  global auswahlfenster
  set auswahlfenster "da"
  toplevel .auswahl
  wm title .auswahl "Suchergebnisse"
  frame   .auswahl.f
  listbox .auswahl.f.anzeige -yscrollcommand ".auswahl.f.sb set"
  scrollbar .auswahl.f.sb -command ".auswahl.f.anzeige yview"
  pack   .auswahl.f.anzeige .auswahl.f.sb -side left -fill y
  pack   .auswahl.f -fill x
  button .auswahl.dismiss -text "Dismiss" -command "destroy .auswahl; set auswahlfenster weg"
  pack .auswahl.dismiss -side bottom -fill x

  bind .auswahl.f.anzeige <Double-Button-1> {
    global auswahlfensterscript  
    set key [lindex [.auswahl.f.anzeige get [ .auswahl.f.anzeige curselection ]] 0 ]
    eval $auswahlfensterscript
  }
}

proc clearauswahl {} {
  .auswahl.f.anzeige delete 0 end
}

proc freiesuche { anw script } {
  global adamsg conn auswahlfensterscript auswahlfenster

  set auswahlfensterscript $script
  puts $anw
  if { $auswahlfenster == "weg" } {
      displayauswahl "Auswahl"
  } else {
      clearauswahl
  }
    
  set res [ pg_exec $conn $anw ]
  set errmsg [pg_result $res -error ]
  if { $errmsg!= "" } {
    setmsg $errmsg
    return 
  }
  
  set at [pg_result $res -numTuples ]
  for { set t 0 } { $t < $at } { incr t } {
    pg_result $res -tupleArray $t r
    set zeile "$r(knr) "
    foreach c [ array names r] {
      append zeile "$r($c) "
    }
    .auswahl.f.anzeige insert end $zeile
  }
}

load libpgtcl.so
set conn [pg_connect postgres ]
set status new
set auswahlfenster "weg"

maske

