-- ----- Grundbuch ---------
-- 1. Buchungstransaktionen
CREATE TABLE btrans
(
  tid SERIAL PRIMARY KEY,
  btext text,
  bdatum datetime,
  aendtaeter varchar(16)
);
CREATE TABLE bfaellig
(
   faellig date,
   bezahltid int4
) INHERITS(btrans);
-- 2. Buchungshalbstze ----
CREATE TABLE btranshs
(
   tid   int4,
   firnr int4,
   knr   varchar(20),
   sh    char(1),
   betrag numeric(8,2) 
);
-- Funktion lasttid braucht man zu schreiben der Halbstze  
CREATE FUNCTION lasttid() RETURNS int4
	AS 'SELECT last_value AS RESULT FROM btrans_tid_seq '
	LANGUAGE 'sql';
-- Rechte fr die Transaktionsrelationen 
GRANT ALL ON btrans TO buch;
GRANT ALL ON btranshs TO buch;
GRANT SELECT ON btrans TO GROUP buch;
GRANT SELECT ON btranshs TO GROUP buch;
GRANT ALL ON bfaellig TO buch;
GRANT SELECT on bfaellig TO GROUP buch; 
GRANT ALL ON btrans_tid_seq TO buch;
