
#ifndef __KONTO_IMPL_H__
#define __KONTO_IMPL_H__

#include "konto.h"


// Implementation for interface Konto
class Konto_impl : virtual public POA_buch::Konto
{
  public:

    buch::Kontonr* get_knr()
      throw(
        ::CORBA::SystemException)
    ;

    char* get_beschreibung()
      throw(
        ::CORBA::SystemException,
        ::buch::databaseerr)
    ;

    buch::Betrag get_saldo()
      throw(
        ::CORBA::SystemException,
        ::buch::databaseerr)
    ;

    buch::Konto_typ get_ktyp()
      throw(
        ::CORBA::SystemException,
        ::buch::databaseerr)
    ;
};


#endif
