/* testet konto */

#include"konto.h"
#include"buchtrans_util.h"

main(int argc,char **argv)
{
  if(argc<2) 
  {
    cerr << "Aufruf: " << argv[0] << " IOR " << endl;
    exit(1);
  }

  CORBA::ORB_var orb = CORBA::ORB_init(argc,argv,"mico-local-orb");
  CORBA::Object_var kobj = orb->string_to_object(argv[1]);
  buch::Konto_var konto = buch::Konto::_narrow(kobj);
  if(CORBA::is_nil(konto))
  {
    cerr << argv[1] << " ist kein Konto " << endl;
    exit(1);
  } 
  buch::Kontonr_var knr = konto->get_knr();
  cout << "Kontonr: " << *knr << endl;
  CORBA::String_var bschr = konto->get_beschreibung();
  cout << bschr << endl;
  switch(konto->get_ktyp())
  {
  case buch::aktiv:   cout << "Aktiv"   << endl; break;
  case buch::passiv:  cout << "Passiv"  << endl; break;
  case buch::aufwand: cout << "Aufwand" << endl; break;
  case buch::ertrag:  cout << "Ertrag"  << endl; break;
  }
  buch::Betrag saldo = konto->get_saldo();
  cout << "Saldo: " << saldo  << endl;
}
