#include"transactionval_impl.h"

CORBA::ValueBase *transaction_factory::create_for_unmarshal()
{
    return new transaction_impl(); 
}

buch::transaction *transaction_factory::create(buch::Tid tid, const char* text, const buch::Halbsatz_seq& hs)
{
    return new transaction_impl(tid,text,hs);
}

CORBA::ValueBase *faelligkeit_factory::create_for_unmarshal()
{
    return new faelligkeit_impl();
}

buch::faelligkeit *faelligkeit_factory::create(buch::Tid tid, const char* text, const buch::Halbsatz_seq& hs,const buch::date& faellig)
{
    return new faelligkeit_impl(tid,text,hs,faellig);
}
